<template>
    <b-modal v-model="modalVisible" class="modal-primary" ref="paymentModalRef" size="lg" title="Cập nhật thông tin giao dịch">
            <div class="modal-body" v-if="payment">
                <span class="text-info col-form-label py-6">Thông tin đại lý: </span>
                <div class="row">
                    
                    <div class="col-md-6 col-xs-12">
                        <div class="row">
                         <label for="agency-name" class="col-md-3">Tên đại lý:</label>
                  <span id="agency-name" class="font-weight-bold col-md-9">{{ payment.agency.name }}</span>
                        </div>
                    </div>
               <div class="col-md-6 col-xs-12">
   <!-- <div class="row">
                    <label for="address" class="col-md-3">Địa chỉ:</label>
                    <span id="address" class="font-weight-bold col-md-9">{{ fullAdress }}</span>
                </div> -->
               </div>
                </div>

             
                <span for="address" class="text-info py-6">Người thanh toán: </span>
                <div class="row">
                    <div class="col-md-6 col-xs-12">
                <div class="row">
                        <label for="customer_name" class="col-md-3">Họ và tên:</label>
                        <span id="customer_name" class="font-weight-bold col-md-9">{{ payment.customer.fullname }}</span>
                </div>
                </div>
                 <div class="col-md-6 col-xs-12">
                <div class="row">
                    <label for="phone_number" class="col-md-3">SĐT:</label>
                    <span id="phone_number" class="font-weight-bold col-md-9">{{ payment.customer.phone_number }}</span>
                </div>
               </div>
                </div>

                <span for="address" class="col-form-label text-info">Người nhận:</span>

                 <div class="row">
                        <label for="salesman_name" class="col-form-label col-md-3">Họ và tên:</label>
                        <span id="salesman_name" class="font-weight-bold col-md-9">{{ payment.salesman.name }}</span>
                </div>
                <div class="row">
                        <label for="role" class="col-form-label col-md-3">Chức vụ:</label>
                        <span id="role" class="font-weight-bold col-md-9">Nhân viên kinh doanh</span>
                </div>
                <div class="form-group">
                  <label for="message-text" class="col-form-label">Số tiền:</label>
                  <div class="input-group">
                        
                        <input type="text" id="amount" class="form-control text-right" aria-label="Amount" min="0" v-model="payment.amount" @keyup="formatCurrency()" :formatter="formatCurrency">
                        <div class="input-group-append">
                          <span class="input-group-text">VNĐ</span>
                        </div>
                      </div>
                      <p><span>Bằng chữ: </span><strong>{{ amountString }}.</strong></p>
                </div>
                <div class="form-group">
                        <label for="message-text" class="col-form-label">Phương thức giao dịch:</label>
                        <select name="payment_method" id="payment_method" class="form-control" v-model="payment.type">
                            <option value="2">Tiền mặt</option>
                            <option value="1">Chuyển khoản</option>
                        </select>
                </div>
                <div class="form-check">
                    <input type="checkbox" class="form-check-input" v-model="resendSMS">
                    <label class="form-check-label" for="resendSMS">Gửi lại tin nhắn?</label>
                </div>
            </div>
            <div class="modal-body" v-else>
                <span>Không tìm thấy dữ liệu hiển thị</span>
            </div>
            <div slot="modal-footer">
              <b-button variant="danger" @click="modalVisible=false">Hủy</b-button>
              <b-button variant="success" @click="updatePayment()" :disabled="isLoading">
               <v-icon v-if="isLoading" name="sync" spin></v-icon>
                {{confirmBtnContent}}</b-button>
            </div>
    </b-modal>
</template>

<script>
import { alerts, convertCurrencyToText, $ } from "../../utils";
import { event } from "../../utils";
import { http } from "@/services";
export default {
  name: "edit-payment-modal",
  data() {
    return {
      confirmBtnContent: "Cập nhật",
      isLoading: false,
      customerOptionVisibility: false,
      modalVisible: false,
      created: false,
      amountString: "",
      resendSMS: false
    };
  },

  props: {
    payment: null
  },
  created() {},
  watch: {
    payment: function() {
      if (this.payment) {
        this.formatCurrency();
      }
    }
  },
  methods: {
    showCustomerOption() {
      this.showCustomerOption != showCustomerOption;
    },
    hideModal() {
      this.modalVisible = false;
    },
    showModal() {
      this.formatCurrency();
      this.modalVisible = true;
    },
    updatePayment() {
      if (!isNaN(this.payment.amount)) {
        alerts.error("Vui lòng nhập số tiền!");
        return false;
      }
      this.isLoading = true;
      this.confirmBtnContent = "Đang xử  lý";
      http.post(
        "payment/update",
        {
          id: this.payment.id,
          amount: this.payment.amount,
          payment_method: this.payment.type,
          resendSMS: this.resendSMS
        },
        response => {
          //return response;
          if (response.data.status) {
            alerts.success(response.data.msg);
          } else {
            alerts.warning(response.data.msg);
          }
          this.resetModuleState();
          this.hideModal();
        },
        error => {
          alerts.error(error.response.statusText);
          this.resetModuleState();
        }
      );
    },
    formatCurrency() {
      if (this.payment) {
        this.payment.amount = this.comma(this.payment.amount);
        let int_amount = this.payment.amount.replace(/,/, "");
        this.amountString = convertCurrencyToText.convert(
          int_amount.replace(/,/, ""),
          "đồng"
        );
      }
    },
    resetModuleState() {
      this.isLoading = false;
      this.confirmBtnContent = "Xác nhận";
    }
  },
  computed: {
    // fullAdress() {
    //   if (
    //     this.payment.agency.province !== null &&
    //     (this.payment.agency.district !== null) &
    //       (this.payment.agency.ward !== null)
    //   ) {
    //     return (
    //       this.payment.agency.address +
    //       " , " +
    //       this.payment.agency.ward.name +
    //       " , " +
    //       this.payment.agency.district.name +
    //       " , " +
    //       this.payment.agency.province.name
    //     );
    //   }
    //   return this.payment.agency.address;
    // },
  }
};
</script>

<style>
</style>
